diff -urN sourceold/scripts/jmgUtility.h source/scripts/jmgUtility.h
--- sourceold/scripts/jmgUtility.h	2019-08-20 10:11:06.817000100 +1000
+++ source/scripts/jmgUtility.h	2020-09-10 09:08:27.972483200 +1000
@@ -157,6 +157,7 @@
 	void Poked(GameObject *obj, GameObject *poker);
 	void Timer_Expired(GameObject *obj,int number);
 };
+
 /*!
 * \brief Basic turret attach script, turrets match team of vehicle attached to, turrets are destroyed by destroy event
 * \Turret_Preset - Preset of the turret
@@ -860,6 +861,37 @@
 	}
 };
 
+/*!
+* \brief Creates a game object at the location of the objective's objective marker while active
+* \ObjectivePriority - Priorities of the objectives that this will create gameobjects for (-2 means ignore requirement)
+* \ObjectiveID - ID of the objective that this will create gameobjects for (-2 means ignore requirement)
+* \Preset - Name of the preset to create
+* \Attach - Should this be attached to the radar marker
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Objective_System_Objective_GameObject : public ScriptImpClass {
+	void Created(GameObject *obj);
+public:
+	int objectiveId;
+	int objectivePriority;
+	char preset[128];
+	bool attach;
+};
+/*!
+* \brief Attached by the objective controller so the code can remove the object when needed
+* \GameObjectID - ID of the gameobject that was created by the controller
+* \MarkerID - ID of the radar marker that this object is tracking
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Objective_System_Objective_GameObject_Tracker : public ScriptImpClass {
+	void Created(GameObject *obj);
+public:
+	int gameObjectId;
+	int markerId;
+};
+
 class NewObjectiveSystem
 {
 	bool objectiveStringIdsLoaded;
@@ -880,6 +912,7 @@
 public:
 	enum Priority{Undefined=-1,Unknown,Primary,Secondary,Tertiary,Quaternary,Quinary,Senary,Septenary,Octonary,Nonary,Denary,Bonus};
 	enum Status{Removed=-2,NotDefined=-1,Pending,Accomplished,Failed,Hidden};
+	int controllerId;
 private:
 	struct ObjectiveNode
 	{
@@ -976,12 +1009,12 @@
 			if (current->id == id)
 				if (current->active)
 				{
-					Destroy_Radar_Marker(Commands->Find_Object(radarMarkerId));
+					Destroy_Radar_Marker(current->radarMarkerId);
 					return false;
 				}
 				else
 				{
-					Destroy_Radar_Marker(Commands->Find_Object(current->radarMarkerId));
+					Destroy_Radar_Marker(current->radarMarkerId);
 					current->id = id;
 					current->priority = priority;
 					current->status = status;
@@ -1011,13 +1044,15 @@
 		}
 		return true;
 	}
-	void Destroy_Radar_Marker(GameObject *marker)
+	void Destroy_Radar_Marker(int markerId)
 	{
+		Destroy_Objective_GameObject(markerId);
+		GameObject *marker = Commands->Find_Object(markerId);
 		if (!marker)
 			return;
 		Commands->Destroy_Object(marker);
 	}
-	GameObject *Create_Radar_Marker(Vector3 pos, Priority priority,const char *modelOverride)
+	GameObject *Create_Radar_Marker(Vector3 pos, Priority priority,int objectiveId,const char *modelOverride)
 	{
 		GameObject *radarMarker = Commands->Create_Object("Daves Arrow",pos);
 		Commands->Set_Player_Type(radarMarker,team);
@@ -1037,6 +1072,7 @@
 			Commands->Set_Obj_Radar_Blip_Shape(radarMarker,RADAR_BLIP_SHAPE_OBJECTIVE);
 			Commands->Set_Obj_Radar_Blip_Color(radarMarker,priority == Primary ? RADAR_BLIP_COLOR_PRIMARY_OBJECTIVE : priority == Secondary ? RADAR_BLIP_COLOR_SECONDARY_OBJECTIVE : RADAR_BLIP_COLOR_TERTIARY_OBJECTIVE);
 		}
+		Create_Objective_GameObject(radarMarker,objectiveId,priority);
 		return radarMarker;
 	}
 public:
@@ -1068,15 +1104,15 @@
 	{
 		if (!blipUnit)
 			return false;
-		GameObject *radarMarker = Create_Radar_Marker(Vector3(),priority,modelOverride);
+		GameObject *radarMarker = Create_Radar_Marker(Commands->Get_Position(blipUnit),priority,objectiveId,modelOverride);
 		if (!radarMarker)
 			return false;
-		Commands->Attach_To_Object_Bone(radarMarker,blipUnit,"origin");
+		Commands->Attach_To_Object_Bone(radarMarker,blipUnit,blipUnit->As_SoldierGameObj() ? "c pelvis" : "origin");
 		return addObjective(objectiveId,priority,status,nameId,soundFilename,descriptionId,Commands->Get_ID(radarMarker),objectiveNumber);
 	}
 	bool Add_Objective(int objectiveId, Priority priority, Status status, unsigned long nameId, char *soundFilename, unsigned long descriptionId,Vector3 blipPosition,const char *modelOverride = NULL,int objectiveNumber = 0)
 	{
-		GameObject *radarMarker = Create_Radar_Marker(blipPosition,priority,modelOverride);
+		GameObject *radarMarker = Create_Radar_Marker(blipPosition,priority,objectiveId,modelOverride);
 		if (!radarMarker)
 			return false;
 		return addObjective(objectiveId,priority,status,nameId,soundFilename,descriptionId,Commands->Get_ID(radarMarker),objectiveNumber);
@@ -1109,11 +1145,11 @@
 		{
 			if (current->id == objectiveId)
 			{
-				Destroy_Radar_Marker(Commands->Find_Object(current->radarMarkerId));
-				GameObject *radarMarker = Create_Radar_Marker(Vector3(),current->priority,modelOverride);
+				Destroy_Radar_Marker(current->radarMarkerId);
+				GameObject *radarMarker = Create_Radar_Marker(Commands->Get_Position(blipUnit),current->priority,objectiveId,modelOverride);
 				if (!radarMarker)
 					return;
-				Commands->Attach_To_Object_Bone(radarMarker,blipUnit,"origin");
+				Commands->Attach_To_Object_Bone(radarMarker,blipUnit,blipUnit->As_SoldierGameObj() ? "c pelvis" : "origin");
 				current->radarMarkerId = Commands->Get_ID(radarMarker);
 				return;
 			}
@@ -1127,7 +1163,7 @@
 		{
 			if (current->id == objectiveId)
 			{
-				Destroy_Radar_Marker(Commands->Find_Object(current->radarMarkerId));
+				Destroy_Radar_Marker(current->radarMarkerId);
 				return;
 			}
 			current = current->next;
@@ -1140,8 +1176,8 @@
 		{
 			if (current->id == objectiveId)
 			{
-				Destroy_Radar_Marker(Commands->Find_Object(current->radarMarkerId));
-				GameObject *radarMarker = Create_Radar_Marker(blipPosition,current->priority,modelOverride);
+				Destroy_Radar_Marker(current->radarMarkerId);
+				GameObject *radarMarker = Create_Radar_Marker(blipPosition,current->priority,objectiveId,modelOverride);
 				if (!radarMarker)
 					return;
 				current->radarMarkerId = Commands->Get_ID(radarMarker);
@@ -1179,7 +1215,7 @@
 							selectMessageAndColor(formatObjectiveString(objectiveCancelledStringNumbered,objectivePrioritieStrings[current->priority],current->objectiveNumber),current->priority);
 						else
 							selectMessageAndColor(formatObjectiveString(objectiveCancelledString,objectivePrioritieStrings[current->priority]),current->priority);
-					Destroy_Radar_Marker(Commands->Find_Object(current->radarMarkerId));
+					Destroy_Radar_Marker(current->radarMarkerId);
 					current->active = false;
 					return true;
 				}
@@ -1373,6 +1409,46 @@
 			return Vector3(1.0f,1.0f,1.0f);
 		}
 	}
+	void Create_Objective_GameObject(GameObject *radarMarker,int objectiveId,int objectivePriority)
+	{
+		GameObject *obj = Commands->Find_Object(controllerId);
+		if (!obj)
+			return;
+		const SimpleDynVecClass<GameObjObserverClass *> & observer_list = obj->Get_Observers();
+		for(int index = 0;index < observer_list.Count();index++)
+			if (!_stricmp(observer_list[index]->Get_Name(),"JMG_Utility_Objective_System_Objective_GameObject"))
+			{
+				JMG_Utility_Objective_System_Objective_GameObject *script = (JMG_Utility_Objective_System_Objective_GameObject*)observer_list[index];
+				if (script && (script->objectiveId == objectiveId || script->objectiveId == -2) && (script->objectivePriority == objectivePriority || script->objectivePriority == -2))
+				{
+					GameObject *object = Commands->Create_Object(script->preset,Commands->Get_Position(radarMarker));
+					if (script->attach)
+						Commands->Attach_To_Object_Bone(object,radarMarker,"origin");
+					char params[128];
+					sprintf(params,"%d,%d",Commands->Get_ID(object),Commands->Get_ID(radarMarker));
+					Commands->Attach_Script(obj,"JMG_Utility_Objective_System_Objective_GameObject_Tracker",params);
+				}
+			}
+	}
+	void Destroy_Objective_GameObject(int markerId)
+	{
+		GameObject *obj = Commands->Find_Object(controllerId);
+		if (!obj)
+			return;
+		const SimpleDynVecClass<GameObjObserverClass *> & observer_list = obj->Get_Observers();
+		for(int index = 0;index < observer_list.Count();index++)
+			if (!_stricmp(observer_list[index]->Get_Name(),"JMG_Utility_Objective_System_Objective_GameObject_Tracker"))
+			{
+				JMG_Utility_Objective_System_Objective_GameObject_Tracker *script = (JMG_Utility_Objective_System_Objective_GameObject_Tracker*)observer_list[index];
+				if (script && script->markerId == markerId)
+				{
+					GameObject *object = Commands->Find_Object(script->gameObjectId);
+					if (object)
+						Commands->Destroy_Object(object);
+					script->Destroy_Script();
+				}
+			}
+	}
 };
 
 class ClientNetworkObjectPositionSync
@@ -1494,6 +1570,393 @@
 	}
 };
 
+class Rp2SimplePositionSystem
+{
+public:
+	struct SimplePositionNode
+	{
+		int id;
+		float facing;
+		Vector3 position;
+		int value;
+		struct SimplePositionNode *next;
+		SimplePositionNode(GameObject *obj,int value = 0)
+		{
+			this->id = Commands->Get_ID(obj);
+			this->facing = Commands->Get_Facing(obj);
+			this->position = Commands->Get_Position(obj);
+			this->value = value;
+			this->next = NULL;
+		}
+	};
+	SimplePositionNode *SimplePositionNodeList;
+	int ObjectCount;
+	Rp2SimplePositionSystem()
+	{
+		ObjectCount = 0;
+		SimplePositionNodeList = NULL;
+	}
+	Rp2SimplePositionSystem &operator += (GameObject *obj)
+	{
+		int id = Commands->Get_ID(obj);
+		SimplePositionNode *Current = SimplePositionNodeList;
+		if (!SimplePositionNodeList)
+			SimplePositionNodeList = new SimplePositionNode(obj);
+		while (Current)
+		{
+			if (Current->id == id)
+				return *this;
+			if (!Current->next)
+			{
+				Current->next = new SimplePositionNode(obj);
+				break;
+			}
+			Current = Current->next;
+		}
+		ObjectCount++;
+		return *this;
+	};
+	Rp2SimplePositionSystem &operator += (SimplePositionNode *node)
+	{
+		SimplePositionNode *Current = SimplePositionNodeList;
+		if (!SimplePositionNodeList)
+			SimplePositionNodeList = node;
+		while (Current)
+		{
+			if (Current->id == node->id)
+				return *this;
+			if (!Current->next)
+			{
+				Current->next = node;
+				break;
+			}
+			Current = Current->next;
+		}
+		ObjectCount++;
+		return *this;
+	};
+	void Empty_List()
+	{
+		ObjectCount = 0;
+		SimplePositionNode *temp,*die;
+		temp = SimplePositionNodeList;
+		while (temp)
+		{
+			die = temp;
+			temp = temp->next;
+			delete die;
+		}
+		SimplePositionNodeList = NULL;
+	}
+	SimplePositionNode *GetRandomFromGroup(int value)
+	{
+		int random = Commands->Get_Random_Int(0,ObjectCount*2),original;
+		original = random;
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			if (random && value == Current->value)
+				random--;
+			if (!random && value == Current->value)
+				return Current;
+			Current = Current->next;
+			if (!Current && original != random && original)
+				Current = SimplePositionNodeList;
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetNextFromGroup(int value,SimplePositionNode *last)
+	{
+		bool found = false;
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			if (found && value == Current->value)
+				return Current;
+			if (Current == last && value == Current->value)
+				found = true;
+			Current = Current->next;
+			if (!Current)
+				Current = SimplePositionNodeList;
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetRandom()
+	{
+		int random = Commands->Get_Random_Int(0,ObjectCount*2);
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			if (random)
+				random--;
+			if (!random)
+				return Current;
+			Current = Current->next;
+			if (!Current)
+				Current = SimplePositionNodeList;
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetNearest(Vector3 pos)
+	{
+		float LongestDistance = 0;
+		SimplePositionNode *TempObject = NULL;
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			float Temp = JmgUtility::SimpleDistance(Current->position,pos);
+			if (!TempObject || Temp < LongestDistance)
+			{
+				TempObject = Current;
+				LongestDistance = Temp;
+			}
+			Current = Current->next;
+		}
+		return TempObject;
+	}
+	SimplePositionNode *GetNearestFromGroup(int groupId,Vector3 pos)
+	{
+		float LongestDistance = 0;
+		SimplePositionNode *TempObject = NULL;
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			if (Current->value == groupId)
+			{
+				float Temp = JmgUtility::SimpleDistance(Current->position,pos);
+				if (!TempObject || Temp < LongestDistance)
+				{
+					TempObject = Current;
+					LongestDistance = Temp;
+				}
+			}
+			Current = Current->next;
+		}
+		return TempObject;
+	}
+	Vector3 GetNearestVector(Vector3 pos)
+	{
+		SimplePositionNode *TempObject = GetNearest(pos);
+		if (TempObject)
+			return TempObject->position;
+		return Vector3();
+	}
+	SimplePositionNode *GetNearestFlat(Vector3 pos)
+	{
+		float LongestDistance = 0;
+		SimplePositionNode *TempObject = NULL;
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			float Temp = JmgUtility::SimpleFlatDistance(Current->position,pos);
+			if (!TempObject || Temp < LongestDistance)
+			{
+				TempObject = Current;
+				LongestDistance = Temp;
+			}
+			Current = Current->next;
+		}
+		return TempObject;
+	}
+	SimplePositionNode *GetRandom(int minVal)
+	{
+		int repeatLimit = ObjectCount;
+		int random = Commands->Get_Random_Int(0,ObjectCount*2);
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			if (random && Current->value <= minVal)
+				random--;
+			if (!random && Current->value <= minVal)
+				return Current;
+			Current = Current->next;
+			if (!Current && repeatLimit)
+			{
+				repeatLimit--;
+				Current = SimplePositionNodeList;
+			}
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetRandomExcluding(SimplePositionNode *node)
+	{
+		int repeatLimit = ObjectCount;
+		int random = Commands->Get_Random_Int(0,ObjectCount*2);
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			if (random)
+				random--;
+			if (!random && node != Current)
+				return Current;
+			Current = Current->next;
+			if (!Current && repeatLimit)
+			{
+				repeatLimit--;
+				Current = SimplePositionNodeList;
+			}
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetRandomLowestValue()
+	{
+		int lowest = -1;
+		SimplePositionNode *current = SimplePositionNodeList;
+		while (current)
+		{
+			if (lowest == -1 || current->value <= lowest)
+				lowest = current->value;
+			current = current->next;
+		}
+		int random = Commands->Get_Random_Int(0,ObjectCount*2)+1;
+		int originalRandom = random;
+		current = SimplePositionNodeList;
+		while (current)
+		{
+			if (random && current->value == lowest)
+				random--;
+			if (!random)
+				return current;
+			current = current->next;
+			if (!current && originalRandom != random)
+				current = SimplePositionNodeList;
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetRandomOutsideOfRange(float range,Vector3 pos)
+	{
+		range *= range;
+		SimplePositionNode *current = SimplePositionNodeList;
+		int random = Commands->Get_Random_Int(0,ObjectCount*2)+1;
+		int originalRandom = random;
+		while (current)
+		{
+			if (JmgUtility::SimpleDistance(current->position,pos) > range && random)
+				random--;
+			if (!random)
+				return current;
+			current = current->next;
+			if (!current && originalRandom != random)
+				current = SimplePositionNodeList;
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetRandomOutsideOfRangeInGroup(int value,float range,Vector3 pos)
+	{
+		range *= range;
+		SimplePositionNode *current = SimplePositionNodeList;
+		int random = Commands->Get_Random_Int(0,ObjectCount*2)+1;
+		int originalRandom = random;
+		while (current)
+		{
+			if (current->value == value && JmgUtility::SimpleDistance(current->position,pos) > range && random)
+				random--;
+			if (current->value == value && !random)
+				return current;
+			current = current->next;
+			if (!current && originalRandom != random)
+				current = SimplePositionNodeList;
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetFurthestInGroup(int value,Vector3 pos)
+	{
+		float LongestDistance = 0;
+		SimplePositionNode *TempObject = NULL;
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			if (Current->value == value)
+			{
+				float Temp = JmgUtility::SimpleDistance(Current->position,pos);
+				if (!TempObject || Temp > LongestDistance)
+				{
+					TempObject = Current;
+					LongestDistance = Temp;
+				}
+			}
+			Current = Current->next;
+		}
+		return TempObject;
+	}
+	SimplePositionNode *GetRandomInsideOfRangeInGroup(int value,float range,Vector3 pos)
+	{
+		range *= range;
+		SimplePositionNode *current = SimplePositionNodeList;
+		int random = Commands->Get_Random_Int(0,ObjectCount*2)+1;
+		int originalRandom = random;
+		while (current)
+		{
+			if (current->value == value && JmgUtility::SimpleDistance(current->position,pos) <= range && random)
+				random--;
+			if (value && !random)
+				return current;
+			current = current->next;
+			if (!current && originalRandom != random)
+				current = SimplePositionNodeList;
+		}
+		return NULL;
+	}
+	SimplePositionNode *GetLowestValueFurthestFromSpot(Vector3 pos)
+	{
+		int lowest = -1;
+		SimplePositionNode *current = SimplePositionNodeList,*bestNode = NULL;
+		while (current)
+		{
+			if (lowest == -1 || current->value <= lowest)
+				lowest = current->value;
+			current = current->next;
+		}
+
+		current = SimplePositionNodeList;
+		float dist = 0;
+		while (current)
+		{
+			float tempDist = JmgUtility::SimpleDistance(pos,current->position);
+			if (!bestNode || tempDist > dist)
+			{
+				bestNode = current;
+				dist = tempDist;
+			}
+			current = current->next;
+		}
+		return bestNode;
+	}
+	SimplePositionNode *GetSpotNotVisibileFromSpot(Vector3 pos);
+	SimplePositionNode *GetNonVisibleSpotFromPlayers(int value);
+	SimplePositionNode *GetFurthestSpotFromPlayers(int value)
+	{
+		SimplePositionNode *current = SimplePositionNodeList,*bestNode = NULL;
+		float dist = 0;
+		while (current)
+		{
+			if (current->value == value)
+			{
+				GameObject *player = Commands->Get_A_Star(current->position);
+				if (!player)
+					continue;
+				float tempDist = JmgUtility::SimpleDistance(Commands->Get_Position(player),current->position);
+				if (!bestNode || tempDist > dist)
+				{
+					bestNode = current;
+					dist = tempDist;
+				}
+			}
+			current = current->next;
+		}
+		return bestNode;
+	}
+	void DecreaseValue()
+	{
+		SimplePositionNode *Current = SimplePositionNodeList;
+		while (Current)
+		{
+			if (Current->value)
+				Current->value--;
+			Current = Current->next;
+		}
+	}
+};
 /*!
 * \brief An object that will have its position synced by JMG_Utility_Sync_System_Controller
 * \author jgray
@@ -1811,7 +2274,9 @@
 };
 
 class JMG_Utility_Dynamic_Clock_Object : public ScriptImpClass {
+	int animSynced[128];
 	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
 	void Destroyed(GameObject *obj);
 };
 
@@ -2587,6 +3052,7 @@
 	AggressiveAttackSpotSystem::AggressiveAttackSpotNode *node;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
+	void Killed(GameObject *obj,GameObject *killer);
 	void Destroyed(GameObject *obj);
 public:
 	JMG_Utility_AI_Aggressive_Attack_Spot_Point()
@@ -3067,6 +3533,8 @@
 * \ArmorPerPlayer - Amount of armor per player to regen (amount*player count)
 * \Rate - Speed to regen
 * \DamageDelay - Amount of time regen must wait to start again after taking damage
+* \ScaleHealthPerHeal - With each heal this value is added to HealthAmount, if the value goes negative it stops healing (value is multiplied by 0.00001)
+* \ScaleArmorPerHeal - With each heal this value is added to ArmorAmount, if the value goes negative it stops healing (value is multiplied by 0.00001)
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -3081,9 +3549,12 @@
 	float rate;
 	float damageDelay;
 	bool enabled;
+	float scaleHealthPerHeal;
+	float scaleArmorPerHeal;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Damaged(GameObject *obj,GameObject *damager,float damage);
+	float ScaleValue(float value,float scale);
 };
 
 /*!
@@ -3495,7 +3966,6 @@
 	bool Grab_Teleport_Spot(GameObject *enter,int attempts);
 };
 
-
 /*!
 * \brief Used by JMG_Utility_Zone_Teleport_To_Random_Wander_Point
 * \author jgray
@@ -3551,6 +4021,7 @@
 * \PresetName - Name of the preset to hunt down and kill
 * \Position - Position to search near
 * \MaxDistance - Max distance to scan, 0 = infinite
+* \TriggerOnce - If non-zero the script can only fire once then removes itself
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -4999,6 +5470,7 @@
 	void Damaged(GameObject *obj,GameObject *damager,float damage);
 	void Poked(GameObject *obj, GameObject *poker);
 	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason reason);
+	void Killed(GameObject *obj, GameObject *killer);
 	void Destroyed(GameObject *obj);
 	void Detach(GameObject *obj);
 	void AttackTarget(GameObject *obj,GameObject *follow,GameObject *target,Vector3 location,float speed,float distance);
